from gi.repository import Nautilus, GObject
import subprocess
import urllib
import os

class Emblemize(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def emblemize_run(self,menu,file):
        emblemize_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/emblemize3',emblemize_path])
        return

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
        else:
            return

        if filecount ==1  and os.path.exists('/usr/bin/emblemize3'):
            file = files[0]
            item = Nautilus.MenuItem(
            name="EmblemizeMenu::Emblemize",
            label="set emblem",
            tip="set emblem"
                )
            item.connect('activate', self.emblemize_run, file)
            return [item]
        else:
            return
