#gedit as menu
#dr3mro@gmail.com
#0.2

from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class Geditas(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass



    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path



    def as_user(self,menu,files):
        files_path=['gedit']
        for file in files:
            gedit_path=self.url2path(file)
            files_path.append(gedit_path)
        subprocess.Popen(files_path)
        return


    def as_root(self,menu,files):
        files_path=['gksu','gedit']
        for file in files:
            gedit_path=self.url2path(file)
            files_path.append(gedit_path)
        subprocess.Popen(files_path)
        return


    def check_mimes(self,files):
        for file in files:
            mime= file.get_mime_type()
            mime_list=mime.split('/')
            allowedmimes=['application/x-designer','application/x-shellscript','application/xml']
            if mime_list[0] =='text':
                none_text=False
            elif mime in allowedmimes:
                none_text=False
            else:
                none_text=True
        return none_text

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
        else:
            return 


        GeditAsTopMenu = Nautilus.MenuItem(name='TopMenuItem::GeditAs', 
                                         label='Gedit as', 
                                         tip='gedit as',
                                    )
        GeditAsSubMenu = Nautilus.Menu()
        GeditAsTopMenu.set_submenu(GeditAsSubMenu)


        none_text=self.check_mimes(files)


        if os.path.exists('/usr/bin/gedit') and not none_text:
            UserMenuItem = Nautilus.MenuItem(name='GeditAsSubMenu::User', 
                                             label='User', 
                                             tip='open this file in gedit as user',
                                        )
            UserMenuItem.connect('activate',self.as_user,files)
            GeditAsSubMenu.append_item(UserMenuItem)

        if os.path.exists('/usr/bin/gedit') and os.path.exists('/usr/bin/gksu') and not none_text:
            RootMenuItem = Nautilus.MenuItem(name='GeditAsSubMenu::Root', 
                                             label='Root', 
                                             tip='open this file in gedit as root',
                                        )
            RootMenuItem.connect('activate',self.as_root,files)
            GeditAsSubMenu.append_item(RootMenuItem)

        return [GeditAsTopMenu]
