from gi.repository import Nautilus, GObject
import subprocess
import urllib
import os

class Imgizor(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def imgizor_run(self,menu,file):
        imgizor_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/imgizor',imgizor_path])
        return

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
            mimetype=file.get_mime_type()
        else:
            mimetype=""

        if filecount ==1  and mimetype[:5] == 'image' and os.path.exists('/usr/bin/imgizor'):
            file = files[0]
            item = Nautilus.MenuItem(
            name="ImgizorMenu::Imgizor",
            label="open with Imgizor",
            tip="open with Imgizor"
                )
            item.connect('activate', self.imgizor_run, file)
            return [item]
        else:
            return
