#dr3mro@gmail.com
#Dr. Amr Osman
#v 1.1

from gi.repository import Nautilus, GObject
import subprocess
import urllib
import os

class MainMenuWallpaper(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        path=urllib.url2pathname(fileuri)
        return path

    def wallpaper_run(self,menu,file):
        wallpaper_path=self.url2path(file)
        subprocess.Popen(['/usr/bin/wallpaper-changer',wallpaper_path])
        return

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount == 0 :
            return
        else :
            file=files[0]
            mimetype=file.get_mime_type()
        if filecount ==1  and mimetype[:5] == 'image' and os.path.exists('/usr/bin/wallpaper-changer'):
            item = Nautilus.MenuItem(
            name="MenuItem::SetasWallpaper",
            label="Set as wallpaper",
            tip="Set as wallpaper"
                )
            item.connect('activate', self.wallpaper_run, file)
            return [item]
        else:
            return
