#Drop-share 0.2
#dr3mro@gmail.com


from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class DropShare(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass



    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path



    def drop_share(self,menu,files):
        files_path=['drop_share']
        for file in files:
            dropshare_path=self.url2path(file)
            files_path.append(dropshare_path)
        subprocess.Popen(files_path)
        return


    def drop_unshare(self,menu,files):
        files_path=['drop_unshare']
        for file in files:
            dropshare_path=self.url2path(file)
            files_path.append(dropshare_path)
        subprocess.Popen(files_path)
        return



    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
            parent_path=self.url2path(file)
            parent_path_list=parent_path.split('/')
            if 'Dropbox' in parent_path_list:
                return
        else: 
            return 



        DropBoxTopMenu = Nautilus.MenuItem(name='TopMenuItem::DropBox', 
                                         label='Dropbox', 
                                         tip='Dropbox',
                                    )
        DropBoxSubMenu = Nautilus.Menu()
        DropBoxTopMenu.set_submenu(DropBoxSubMenu)

        if os.path.exists('/usr/bin/drop_share'):
            DropShareMenuItem = Nautilus.MenuItem(name='DropShareSubMenu::DropShare', 
                                             label='Share', 
                                             tip='share with dropbox',
                                        )
            DropShareMenuItem.connect('activate',self.drop_share,files)
            DropBoxSubMenu.append_item(DropShareMenuItem)

        if os.path.exists('/usr/bin/drop_unshare'):
            DropUnshareMenuItem = Nautilus.MenuItem(name='DropUnshareSubMenu::DropUnshare', 
                                             label='Unshare', 
                                             tip='unshare with dropbox',
                                        )
            DropUnshareMenuItem.connect('activate',self.drop_unshare,files)
            DropBoxSubMenu.append_item(DropUnshareMenuItem)

        return [DropBoxTopMenu]
