#execute as menu
#Dr. Amr Osman
#dr3mro@gmail.com
#0.2

from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class ExcuteAs(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass



    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path



    def as_user(self,menu,file):
        file_path=self.url2path(file)
        dirname=os.path.dirname(file_path)
        script=os.path.basename(file_path)
        os.chdir(dirname)
        dotslash='./'+script
        subprocess.Popen([dotslash])
        return


    def as_root(self,menu,file):
        file_path=self.url2path(file)
        dirname=os.path.dirname(file_path)
        script=os.path.basename(file_path)
        os.chdir(dirname)
        dotslash='./'+script
        subprocess.Popen(['gksu',dotslash])
        return


    def check_mimes(self,file):
        mime= file.get_mime_type()
        allowedmimes=['application/x-shellscript','text/x-python','application/x-executable']
        if mime in allowedmimes:
            supported=True
        else:
            supported=False
        return supported

    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
            supported=self.check_mimes(file)
        ExecuteAsTopMenu = Nautilus.MenuItem(name='TopMenuItem::ExecuteAs', 
                                         label='Execute as', 
                                         tip='Execute as',
                                    )
        ExecuteAsSubMenu = Nautilus.Menu()
        ExecuteAsTopMenu.set_submenu(ExecuteAsSubMenu)



        if filecount == 1 and supported:
            UserMenuItem = Nautilus.MenuItem(name='ExecuteAsSubMenu::User', 
                                             label='User', 
                                             tip='excute this script as user',
                                        )
            UserMenuItem.connect('activate',self.as_user,file)
            ExecuteAsSubMenu.append_item(UserMenuItem)

        if filecount == 1 and supported:
            RootMenuItem = Nautilus.MenuItem(name='ExecuteAsSubMenu::Root', 
                                             label='Root', 
                                             tip='execute this script as root',
                                        )
            RootMenuItem.connect('activate',self.as_root,file)
            ExecuteAsSubMenu.append_item(RootMenuItem)

        return [ExecuteAsTopMenu]
