#nautilus open as root
#dr3mro@gmail.com
#version 0.2

from gi.repository import Nautilus, GObject
import subprocess,os
import urllib
import re


class OpenAsRoot(GObject.GObject, Nautilus.MenuProvider):

    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return re.escape(path)

    def run(self, menu,url):
        path=self.url2path(url)
        args="gvfs-open %s" %path
        subprocess.Popen(["gksu",args])

    def get_file_items(self, window, files):
        if len(files) != 1:
            return

        file = files[0]

        item = Nautilus.MenuItem(
                name="MenuItem:OpenAsRoot",
                label="Open as Root...",
                tip="Open as Root !",
                icon="face-devilish"
            )

        item.connect('activate', self.run,file)
        return [item]
