#(un)hide 0.2
#dr3mro@gmail.com


from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class Visibility(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass



    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path



    def hide(self,menu,files):
        files_path=['hider']
        for file in files:
            hide_path=self.url2path(file)
            files_path.append(hide_path)
        subprocess.Popen(files_path)
        return


    def unhide(self,menu,files):
        files_path=['unhider']
        for file in files:
            unhide_path=self.url2path(file)
            files_path.append(unhide_path)
        subprocess.Popen(files_path)
        return



    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount > 0 :
            file=files[0]
        else: 
            return 

        VisibilityTopMenu = Nautilus.MenuItem(name='TopMenuItem::Visibility', 
                                         label='(Un)Hide', 
                                         tip='hide / unhide',
                                    )
        VisibilitySubMenu = Nautilus.Menu()
        VisibilityTopMenu.set_submenu(VisibilitySubMenu)

        if os.path.exists('/usr/bin/hider'):
            HideMenuItem = Nautilus.MenuItem(name='HideSubMenu::Hide', 
                                             label='Hide', 
                                             tip='hide',
                                        )
            HideMenuItem.connect('activate',self.hide,files)
            VisibilitySubMenu.append_item(HideMenuItem)

        if os.path.exists('/usr/bin/unhider'):
            UnhideMenuItem = Nautilus.MenuItem(name='UnhideSubMenu::Unhide', 
                                             label='UnHide', 
                                             tip='unhide',
                                        )
            UnhideMenuItem.connect('activate',self.unhide,files)
            VisibilitySubMenu.append_item(UnhideMenuItem)

        return [VisibilityTopMenu]
